- name: Check if Docker CE is installed
  yum:
    list: "docker-ce"
  register: docker_is_installed

- name: Variable cooking
  set_fact:
    docker_not_installed: >-
      {{ docker_is_installed.results | selectattr("yumstate", "match", "installed") | list | length == 0 }}

- when: docker_not_installed
  block:
    - name: Check if EPEL repository is already installed
      stat:
        path: "{{ docker_registry_epel_repofile_path }}"
      register: epel_repofile

    - name: Install EPEL repository
      yum:
        name: "{{ docker_registry_epel_repo_url }}"
        state: present
      register: epel_repo_install
      retries: 5
      delay: 10
      until: epel_repo_install.rc == 0

    - name: Import EPEL repository GPG key
      rpm_key:
        key: "{{ docker_registry_epel_repo_gpg_key_url }}"

    - name: Set yum repository
      yum_repository:
        name: "docker-ce-stable"
        description: "Docker CE Stable"
        baseurl: "https://download.docker.com/linux/centos/7/$basearch/stable"
        enabled: yes
        gpgcheck: yes
        gpgkey: https://download.docker.com/linux/centos/gpg

    - name: Install Docker CE
      yum:
        name: "docker-ce"
        state: present
        update_cache: yes

- name: Check if python-pip is installed
  yum:
    list: "python-pip"
  register: pip_is_installed

- name: Install docker-py
  pip:
    name: docker-py
  register: docker_py_is_installed
  ignore_errors: true

- when: docker_py_is_installed.failed
  block:
    - name: Install python-pip
      yum:
        name: python-pip
        state: present
        update_cache: yes

    - name: Install docker-py
      pip:
        name: docker-py

- name: Start and enable docker daemon
  systemd:
    name: docker
    state: started
    enabled: yes

- name : Create and start docker registry
  docker_container:
    state: started
    restart_policy: always
    name: "{{ docker_registry_container_name }}"
    image: "{{ docker_registry_container }}"
    pull: true
    published_ports:
      - "127.0.0.1:{{ docker_registry_port }}:5000"
